<template>
  <div class="min-h-full flex flex-col justify-center">

    <div class="mt-8 sm:mx-auto sm:w-full">
      <div class="bg-white py-8 px-4 shadow sm:rounded-lg sm:px-10">
        <form class="space-y-6 grid" @submit.prevent="updateRover">
          <div class="grid grid-cols-4 gap-5">
            <div>
              <label for="rover-name" class="block text-sm font-medium text-gray-700">Rover Name</label>
              <div class="mt-1">
                <input v-model="rover_name" id="rover-name" name="rover-name" type="text" required 
                class="appearance-none block w-full px-3 py-2 border border-gray-300 rounded-md 
                  shadow-sm placeholder-gray-400 focus:outline-none focus:ring-blue-600
                  focus:border-blue-600 sm:text-sm">
              </div>
            </div>

            <div>
              <label for="landing-x" class="block text-sm font-medium text-gray-700">Landing position X</label>
              <div class="mt-1">
                <input v-model="landing_x" id="landing-x" name="landing-x" type="number" required 
                class="appearance-none block w-full px-3 py-2 border border-gray-300 rounded-md 
                  shadow-sm placeholder-gray-400 focus:outline-none focus:ring-blue-600
                  focus:border-blue-600 sm:text-sm">
              </div>
            </div>

            <div>
              <label for="landing-y" class="block text-sm font-medium text-gray-700">Landing position Y</label>
              <div class="mt-1">
                <input v-model="landing_y" id="landing-y" name="landing-y" type="number" required 
                class="appearance-none block w-full px-3 py-2 border border-gray-300 rounded-md 
                  shadow-sm placeholder-gray-400 focus:outline-none focus:ring-blue-600
                  focus:border-blue-600 sm:text-sm">
              </div>
            </div>

            <div>
              <label for="direction" class="block text-sm font-medium text-gray-700">Direction</label>
              <div class="mt-1">
                <select v-model="direction" type="text" class="appearance-none block w-full px-3 py-2 border border-gray-300 rounded-md 
                  shadow-sm placeholder-gray-400 focus:outline-none focus:ring-blue-600
                  focus:border-blue-600 sm:text-sm">
                    <option disabled selected value="" >Choose...</option>
                    <option value="N">North</option>
                    <option value="E">East</option>
                    <option value="S">South</option>
                    <option value="W">West</option>
                </select>
              </div>
            </div>
          </div>
          <div>
            <label for="instrucctions" class="block text-sm font-medium text-gray-700">Instrucctions</label>
            <div class="mt-1">
              <input v-model="instrucctions" id="instrucctions" name="instrucctions" type="text" required 
              class="appearance-none block w-full px-3 py-2 border border-gray-300 rounded-md 
                shadow-sm placeholder-gray-400 focus:outline-none focus:ring-blue-600
                focus:border-blue-600 sm:text-sm">
            </div>
          </div>

          <div>
            <button type="submit" 
            class="w-full flex justify-center py-2 px-4 border border-transparent rounded-md 
              shadow-sm text-sm font-medium text-white bg-blue-600
            hover:bg-blue-700 focus:outline-none focus:ring-2 focus:ring-offset-2 
            focus:ring-blue-600">
              Save
            </button>
          </div>
        </form>
        <!-- Errors section  -->
        <div class="pt-4">
          <p class="p-1 text-red-600 font-bold" v-for="(error, errorIdx) in errors" :key="errorIdx">
            {{ error[0] }}
          </p>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  props:{
    roverInfo: {
      type: Object,
      required: true
    },
    getRoversDetails: {
      type: Function,
      required:true
    }
  },
  data(){
    return {
      rover_id:'',
      rover_name:'',
      landing_x:'',
      landing_y:'',
      direction:'',
      instrucctions:'',
      errors:''
    }
  },
  mounted(){
    this.rover_id = this.roverInfo.id
    this.rover_name = this.roverInfo.name
    this.landing_x = this.roverInfo.x_position
    this.landing_y = this.roverInfo.y_position
    this.direction = this.roverInfo.direction
    this.instrucctions = this.roverInfo.instructions
  },
  methods: {
    updateRover(){
      this.errors = ''
      const data = {
        "name": this.rover_name,
        "x_position": this.landing_x,
        "y_position": this.landing_y,
        "direction": this.direction,
        "instructions": this.instrucctions
      }
      this.$axios.put(`rover/${this.rover_id}/`,data)
        .then((response) => {
          this.getRoverDetails()
        })
        .catch((error) => {
          this.errors = error.response.data
        })
    },
    getRoverDetails(){
      this.$axios.get(`rover/${this.rover_id}`)
        .then((response) => {
          this.rover_name = response.data.name
          this.landing_x = response.data.x_position
          this.landing_y = response.data.y_position
          this.direction = response.data.direction
          this.instrucctions = response.data.instructions
        })
    }
  }
}
</script>